%=======================================================================
%To solve optimization problem:
%Create a new subfolder in ...\PSG\MATLAB:
%..\PSG\MATLAB\problem_Hull_variance
%Download and unpack the following zipped file from 'Data' to the created folder:
%'Mat_data_problem_Hull_variance.zip'
%Run program 'problem_Hull_variance.m'
%=======================================================================

clc;
clear;
addpath('..');

%Load data:
load('.\problem_Hull_variance_data.mat')
%Define options for PSG solver:
stroptions.Linearization = 'On';
%Define input arguments:
string = {'variance'};
w = {[]};

%Solve optimization problems:
[xout, fval, status, output] = riskprog(string, [], H, [], [], [], [], [], Aeq, beq, lb, ub, [], stroptions);
 
%Display results:
disp(' ');
disp('Results: ');
%Display status of optimization problem:
disp(sprintf('status of optimization problem = %s', status));
%Display solving time:
disp(sprintf('solving time = %g', output.solving_time));
%Display objective:
disp(sprintf('objective = %g', fval));
%Display function:
disp(sprintf('variance= %g', output.frval));
%Display left hand sides of linear equality:
disp(sprintf('linear equality = %g', output.fAeqval));
%Display residual of linear equality:
disp(sprintf('residual of linear equality = %g', output.rAeqval));
%Display optimal point:
disp('optimal point = ');
disp(xout');
